#!/bin/bash
#
# Subject: 定数の定義と削除
# Warning: このスクリプトは、実行して確認するためのものではない。実行しないように
#
# Description: 対話シェルで、この手順でやればうまくいくという例

echo "==定数変数の定義と削除=="
declare -r c=ok
echo "c=$c" #=> c=ok
c=ok?   #=> -bash: c: readonly variable
unset c # 変数cを削除 => -bash: unset: c: cannot unset: readonly variable ← エラーとなる
exec $0 "$@"  # 実行中のスクリプトを再起動
# ここからは、実行されないで、新く起動したプロセスがスクリプトの先頭から実行
echo "c=$c" #=> c= ...しっかりと消えている

# 同様に環境変数なら
echo "==環境変数の定数定義と削除=="
readonly a=10 # declare -c と同じ意味
echo "a=$a" #=> a=10
export a
unset a #=> エラー
exec $0 "$@"  # 実行中のスクリプトを再起動
# ここからは、実行されないで、新しく起動したプロセスがスクリプトの先頭から実行
echo "a=$a" #=> a=10  ... 環境変数として存在
unset a # 削除できる
